-- Net Show Proxy 


-- behavior library version 1.1

-- polls the member to see if it's loaded and switches the proxy out when loaded.  Requires 
-- PrepareFrame event so this won't work in a tempo channel wait.  Keep the play head moving
-- or use a go the frame loop. 


property proxy, heromember, proxyforecolor, proxybackcolor
property saveback, savefore

on beginsprite me
  set the saveback of me = the backcolor of sprite the spritenum of me
  set the savefore of me = the forecolor of sprite the spritenum of me
  set the heromember of me = the member of sprite the spritenum of me
  set the member of sprite the spritenum of me = member proxy
  set the forecolor of sprite the spritenum of me = the proxyforecolor of me
  set the backcolor of sprite the spritenum of me = the proxybackcolor of me
end


on prepareframe me
  if the mediaReady of member the heromember of me then
    set the member of sprite the spritenum of me = member the heromember of me
    set the backcolor of sprite the spritenum of me = the saveback of me
    set the forecolor of sprite the spritenum of me = the savefore of me
  end if
end


on getPropertyDescriptionList
  if the currentspritenum = 0 then 
    set memdefault = 0 
  else
    set memref = the member of sprite the currentspritenum
    set castlibnum = the castlibnum of memref
    set memdefault = member (the membernum of member memref + 1) of castlib castlibnum
  end if
  
  set p_list = []
  
  set  p_list= [ #proxy: [ #comment:"Proxy Castmember:",#format: #shape, #default:memdefault ], #proxyforecolor: [ #comment:   "Foreground Color Index:",#format:  #integer, #default:    255 ],#proxybackcolor:  [ #comment:   "Background Color Index:", #format: #integer, #default:    0 ]]
  
  
  return p_list
end

on getBehaviorDescription 
  return "Displays a designated placeholder image while media is being retrieved from the network.  Allows  a simple graphic (usually a shape) to be displayed while larger cast members load.  Automatically replaces the proxy with actual media when the media finishes downloading. Drag this behavior to a sprite that displays a large cast member that may download slowly." & RETURN & "PARAMETERS:" & RETURN & "• Proxy Castmember - Enter the name of the internal cast member that should serve as a placeholder."
  
  
end
